]> arthur.barton.de Git - bup.git/blobdiff - Makefile
Split src tree python use to config/bin/python and dev/bup-python
[bup.git] / Makefile
index 201af4c424722cb747c0fc0e9cc580aa318e0d3a..4ca1a031c7c2a3daf362849a782e7f364e5a7ce7 100644 (file)
--- a/Makefile
+++ b/Makefile
@@ -3,9 +3,10 @@ SHELL := bash
 .DEFAULT_GOAL := all
 
 # See config/config.vars.in (sets bup_python, among other things)
-include config/config.vars
+-include config/config.vars
 
 pf := set -o pipefail
+cfg_py := $(CURDIR)/config/bin/python
 
 define isok
   && echo " ok" || echo " no"
@@ -42,30 +43,39 @@ endif
 initial_setup := $(shell ./configure-version --update $(isok))
 initial_setup := $(call shout,$(initial_setup),Version configuration failed))
 
-config/config.vars: configure config/configure config/configure.inc \
+config/config.vars: \
+  configure config/configure config/configure.inc \
   $(wildcard config/*.in)
        MAKE="$(MAKE)" ./configure
 
-bup_cmds := cmd/bup-python\
+# On some platforms, Python.h and readline.h fight over the
+# _XOPEN_SOURCE version, i.e. -Werror crashes on a mismatch, so for
+# now, we're just going to let Python's version win.
+readline_cflags += $(shell pkg-config readline --cflags)
+readline_xopen := $(filter -D_XOPEN_SOURCE=%,$(readline_cflags))
+readline_xopen := $(subst -D_XOPEN_SOURCE=,,$(readline_xopen))
+ifneq ($(readline_xopen),600)
+  $(error "Unexpected pkg-config readline _XOPEN_SOURCE --cflags $(readline_cflags)")
+endif
+readline_cflags := $(filter-out -D_XOPEN_SOURCE=%,$(readline_cflags))
+readline_cflags += $(addprefix -DBUP_RL_EXPECTED_XOPEN_SOURCE=,$(readline_xopen))
+
+CFLAGS += $(readline_cflags)
+LDFLAGS += $(shell pkg-config readline --libs)
+
+config/bin/python: config/config.vars
+
+bup_cmds := \
   $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
   $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
 
-bup_deps := bup lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
+bup_deps := lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
 
 all: $(bup_deps) Documentation/all $(current_sampledata)
 
-bup:
-       ln -s main.py bup
-
 $(current_sampledata):
        t/configure-sampledata --setup
 
-define install-python-bin
-  set -e; \
-  sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
-  chmod 0755 $2;
-endef
-
 PANDOC ?= $(shell type -p pandoc)
 
 ifeq (,$(PANDOC))
@@ -98,11 +108,14 @@ install: all
        test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
        test -z "$(man_html)" || install -d $(dest_docdir)
        test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
-       $(call install-python-bin,bup,"$(dest_bindir)/bup")
+       dev/install-python-script lib/cmd/bup "$(dest_libdir)/cmd/bup"
        set -e; \
-       for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
-         $(call install-python-bin,"$$cmd","$(dest_libdir)/$$cmd") \
+       for cmd in $$(ls cmd/bup-*); do \
+         dev/install-python-script "$$cmd" "$(dest_libdir)/$$cmd"; \
        done
+       cd "$(dest_bindir)" && \
+         ln -sf "$$($(bup_python) -c 'import os; print(os.path.relpath("$(abspath $(dest_libdir))/cmd/bup"))')"
+       set -e; \
        $(INSTALL) -pm 0644 \
                lib/bup/*.py \
                $(dest_libdir)/bup
@@ -119,14 +132,13 @@ install: all
 config/config.h: config/config.vars
 
 lib/bup/_helpers$(SOEXT): \
-               config/config.h \
+               config/config.h lib/bup/bupsplit.h \
                lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
        @rm -f $@
-       cd lib/bup && \
-       LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
+       cd lib/bup && $(cfg_py) csetup.py build "$(CFLAGS)" "$(LDFLAGS)"
         # Make sure there's just the one file we expect before we copy it.
-       find lib/bup/build/* -maxdepth 1 -name '_helpers*$(SOEXT)' -print0 \
-         | tr -C -d '\000' | wc -c | xargs test 1 -eq
+       $(cfg_py) -c \
+         "import glob; assert(len(glob.glob('lib/bup/build/*/_helpers*$(SOEXT)')) == 1)"
        cp lib/bup/build/*/_helpers*$(SOEXT) "$@"
 
 lib/bup/_checkout.py:
@@ -142,52 +154,83 @@ t/tmp:
 
 runtests: runtests-python runtests-cmdline
 
+python_tests := \
+  lib/bup/t/tbloom.py \
+  lib/bup/t/tclient.py \
+  lib/bup/t/tgit.py \
+  lib/bup/t/thashsplit.py \
+  lib/bup/t/thelpers.py \
+  lib/bup/t/tindex.py \
+  lib/bup/t/tmetadata.py \
+  lib/bup/t/toptions.py \
+  lib/bup/t/tresolve.py \
+  lib/bup/t/tshquote.py \
+  lib/bup/t/tvfs.py \
+  lib/bup/t/tvint.py \
+  lib/bup/t/txstat.py
+
 # The "pwd -P" here may not be appropriate in the long run, but we
 # need it until we settle the relevant drecurse/exclusion questions:
 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
 runtests-python: all t/tmp
+       mkdir -p t/tmp/test-log
        $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
-         "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
+         ./wvtest.py  $(python_tests) 2>&1 \
            | tee -a t/tmp/test-log/$$$$.log
 
 cmdline_tests := \
+  t/test.sh \
+  t/test-argv \
+  t/test-cat-file.sh \
+  t/test-command-without-init-fails.sh \
+  t/test-compression.sh \
+  t/test-drecurse.sh \
+  t/test-fsck.sh \
+  t/test-fuse.sh \
   t/test-ftp \
-  t/test-save-restore \
-  t/test-packsizelimit \
-  t/test-prune-older \
   t/test-web.sh \
-  t/test-rm.sh \
   t/test-gc.sh \
-  t/test-main.sh \
-  t/test-list-idx.sh \
+  t/test-import-duplicity.sh \
+  t/test-import-rdiff-backup.sh \
   t/test-index.sh \
-  t/test-split-join.sh \
-  t/test-fuse.sh \
-  t/test-drecurse.sh \
-  t/test-cat-file.sh \
-  t/test-compression.sh \
-  t/test-fsck.sh \
-  t/test-index-clear.sh \
   t/test-index-check-device.sh \
+  t/test-index-clear.sh \
+  t/test-list-idx.sh \
   t/test-ls \
   t/test-ls-remote \
-  t/test-tz.sh \
+  t/test-main.sh \
   t/test-meta.sh \
   t/test-on.sh \
+  t/test-packsizelimit \
+  t/test-prune-older \
+  t/test-redundant-saves.sh \
   t/test-restore-map-owner.sh \
   t/test-restore-single-file.sh \
+  t/test-rm.sh \
   t/test-rm-between-index-and-save.sh \
-  t/test-save-with-valid-parent.sh \
-  t/test-sparse-files.sh \
-  t/test-command-without-init-fails.sh \
-  t/test-redundant-saves.sh \
   t/test-save-creates-no-unrefs.sh \
+  t/test-save-restore \
+  t/test-save-errors \
   t/test-save-restore-excludes.sh \
   t/test-save-strip-graft.sh \
-  t/test-import-duplicity.sh \
-  t/test-import-rdiff-backup.sh \
-  t/test-xdev.sh \
-  t/test.sh
+  t/test-save-with-valid-parent.sh \
+  t/test-sparse-files.sh \
+  t/test-split-join.sh \
+  t/test-tz.sh \
+  t/test-xdev.sh
+
+tmp-target-run-test-get-%: all t/tmp
+       $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
+         t/test-get $* 2>&1 | tee -a t/tmp/test-log/$$$$.log
+
+test_get_targets += \
+  tmp-target-run-test-get-replace \
+  tmp-target-run-test-get-universal \
+  tmp-target-run-test-get-ff \
+  tmp-target-run-test-get-append \
+  tmp-target-run-test-get-pick \
+  tmp-target-run-test-get-new-tag \
+  tmp-target-run-test-get-unnamed
 
 # For parallel runs.
 # The "pwd -P" here may not be appropriate in the long run, but we
@@ -197,7 +240,7 @@ tmp-target-run-test%: all t/tmp
        $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
          t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
 
-runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
+runtests-cmdline: $(test_get_targets) $(subst t/test,tmp-target-run-test,$(cmdline_tests))
 
 stupid:
        PATH=/bin:/usr/bin $(MAKE) test
@@ -206,7 +249,7 @@ test: all
        if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
        mkdir -p t/tmp/test-log
        ./wvtest watch --no-counts \
-         $(MAKE) runtests-python runtests-cmdline 2>t/tmp/test-log/$$$$.log
+         $(MAKE) runtests 2>t/tmp/test-log/$$$$.log
        ./wvtest report t/tmp/test-log/*.log
 
 check: test
@@ -214,11 +257,16 @@ check: test
 distcheck: all
        ./wvtest run t/test-release-archive.sh
 
-cmd/python-cmd.sh: config/config.vars Makefile
-       printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
-         >> cmd/python-cmd.sh.$$PPID.tmp
-       chmod +x cmd/python-cmd.sh.$$PPID.tmp
-       mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh
+long-test: export BUP_TEST_LEVEL=11
+long-test: test
+
+long-check: export BUP_TEST_LEVEL=11
+long-check: check
+
+.PHONY: check-both
+check-both:
+       $(MAKE) clean && PYTHON=python3 $(MAKE) check
+       $(MAKE) clean && PYTHON=python2 $(MAKE) check
 
 cmd/bup-%: cmd/%-cmd.py
        rm -f $@
@@ -264,15 +312,18 @@ import-docs: Documentation/clean
        $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
        $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
 
-clean: Documentation/clean cmd/bup-python
+clean: Documentation/clean config/bin/python
+       cd config && rm -rf config.var
        cd config && rm -f *~ .*~ \
          ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
        rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
                .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
                *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
-               bup bup-* \
                randomgen memtest \
                testfs.img lib/bup/t/testfs.img
+       for x in $$(ls cmd/*-cmd.py cmd/*-cmd.sh | grep -vF python-cmd.sh | cut -b 5-); do \
+           echo "cmd/bup-$${x%-cmd.*}"; \
+       done | xargs -t rm -f
        if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
        if test -e t/mnt; then rm -r t/mnt; fi
        if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
@@ -284,4 +335,4 @@ clean: Documentation/clean cmd/bup-python
        ./configure-version --clean
        t/configure-sampledata --clean
         # Remove last so that cleanup tools can depend on it
-       rm -f cmd/bup-* cmd/python-cmd.sh
+       rm -rf config/bin